﻿Imports System.ComponentModel
Imports System.Runtime.CompilerServices

<Serializable>
Public Class NotifyPropertyChanged : Implements INotifyPropertyChanged

	<NonSerialized>
	Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

	Protected Sub ChangePropIfDifferent(Of T)(value As T, ByRef backingField As T, <CallerMemberName> Optional propName As String = "")
		If Object.Equals(value, backingField) Then Return
		backingField = value
		RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propName))
	End Sub

End Class
