﻿Imports System.IO
Imports System.Runtime.CompilerServices


Public Module SystemIOX

	''' <summary>Achtung! FileInfo.OpenWrite ist ungeeignet, denn es erneuert nicht unbedingt die ganze Datei</summary>
	<Extension()>
	Public Sub Serialize(fi As FileInfo, obj As Object)
		Using strm = fi.Open(FileMode.Create)
			strm.Serialize(obj)
		End Using
	End Sub
	<Extension()>
	Public Sub Serialize(strm As Stream, obj As Object)
		Call (New Runtime.Serialization.Formatters.Binary.BinaryFormatter).Serialize(strm, obj)
	End Sub
	<Extension()>
	Public Function Deserialize(Of T)(fi As FileInfo) As T
		Using strm = fi.OpenRead
			Return strm.Deserialize(Of T)()
		End Using
	End Function
	<Extension()>
	Public Function Deserialize(Of T)(strm As Stream) As T
		Return DirectCast((New Runtime.Serialization.Formatters.Binary.BinaryFormatter).Deserialize(strm), T)
	End Function

End Module
