﻿Imports System.ComponentModel
Public Class DataRecord : Inherits NotifyPropertyChanged

#Region "Bindable Properties"
	Public Property EK() As Decimal
		Get
			Return _EK
		End Get
		Set
			ChangePropIfDifferent(Value, _EK)
		End Set
	End Property
	Private _EK As Decimal

	Public Property VK() As Decimal
		Get
			Return _VK
		End Get
		Set
			ChangePropIfDifferent(Value, _VK)
		End Set
	End Property

	Private _VK As Decimal
	Public Property EbayGebuehr() As Decimal
		Get
			Return _EbayGebuehr
		End Get
		Set
			ChangePropIfDifferent(Value, _EbayGebuehr)
		End Set
	End Property
	Private _EbayGebuehr As Decimal
	Public Property EbayGeb_Satz() As Decimal
		Get
			Return _EbayGeb_Satz
		End Get
		Set
			ChangePropIfDifferent(Value, _EbayGeb_Satz)
		End Set
	End Property
	Private _EbayGeb_Satz As Decimal

	Public Property PayPalGebuehr() As Decimal
		Get
			Return _PayPalGebuehr
		End Get
		Set
			ChangePropIfDifferent(Value, _PayPalGebuehr)
		End Set
	End Property
	Private _PayPalGebuehr As Decimal
	Public Property PayPalGebuehr_Satz() As Decimal
		Get
			Return _PayPalGebuehr_Satz
		End Get
		Set
			ChangePropIfDifferent(Value, _PayPalGebuehr_Satz)
		End Set
	End Property
	Private _PayPalGebuehr_Satz As Decimal

	Public Property PayPalKaeuferSchutz() As Decimal
		Get
			Return _PayPalKaeuferSchutz
		End Get
		Set
			ChangePropIfDifferent(Value, _PayPalKaeuferSchutz)
		End Set
	End Property
	Private _PayPalKaeuferSchutz As Decimal
	Public Property VersandKosten() As Decimal
		Get
			Return _VersandKosten
		End Get
		Set
			ChangePropIfDifferent(Value, _VersandKosten)
		End Set
	End Property
	Private _VersandKosten As Decimal
	Public Property BewerbungsKosten() As Decimal
		Get
			Return _BewerbungsKosten
		End Get
		Set
			ChangePropIfDifferent(Value, _BewerbungsKosten)
		End Set
	End Property
	Private _BewerbungsKosten As Decimal
	Public Property MwSt_Bewerb() As Decimal
		Get
			Return _MwSt_Bewerb
		End Get
		Set
			ChangePropIfDifferent(Value, _MwSt_Bewerb)
		End Set
	End Property
	Public Property BewerbProzent() As Decimal
		Get
			Return _BewerbProzent
		End Get
		Set
			ChangePropIfDifferent(Value, _BewerbProzent)
		End Set
	End Property
	Private _BewerbProzent As Decimal

	Private _MwSt_Bewerb As Decimal
	Public Property MwSt_Satz() As Decimal
		Get
			Return _MwSt_Satz
		End Get
		Set
			ChangePropIfDifferent(Value, _MwSt_Satz)
		End Set
	End Property
	Private _MwSt_Satz As Decimal

	Public Property GebuehrenGesamt() As Decimal
		Get
			Return _GebuehrenGesamt
		End Get
		Set
			ChangePropIfDifferent(Value, _GebuehrenGesamt)
		End Set
	End Property
	Private _GebuehrenGesamt As Decimal
	Public Property Gewinn() As Decimal
		Get
			Return _Gewinn
		End Get
		Set
			ChangePropIfDifferent(Value, _Gewinn)
		End Set
	End Property
	Private _Gewinn As Decimal
	Public Property Auszahlen() As Decimal
		Get
			Return _Auszahlen
		End Get
		Set
			ChangePropIfDifferent(Value, _Auszahlen)
		End Set
	End Property
	Private _Auszahlen As Decimal

#End Region' Bindable Properties

	Public Sub New()
		AC()
	End Sub
	Friend Sub AC()
		EK = 0 : VK = 0 : Auszahlen = 0 : BewerbProzent = 0 : EbayGebuehr = 0 : EbayGeb_Satz = 10 : GebuehrenGesamt = 0 : Gewinn = 0 : MwSt_Bewerb = 0 : MwSt_Satz = 19 : PayPalGebuehr_Satz = 2.49D : PayPalGebuehr = 0 : PayPalKaeuferSchutz = 0.35D : VersandKosten = 0
	End Sub

	Public Sub Berechnen()
		GebuehrenGesamt = EbayGebuehr + PayPalGebuehr + PayPalKaeuferSchutz + BewerbungsKosten + VersandKosten
		Gewinn = VK - EK - GebuehrenGesamt
		Auszahlen = Gewinn / 2
	End Sub
End Class
